<script>
/*
 * # Learning Vue: SingleFileComponentExample.vue
 *
 * DISCLAIMER: The following SingleFileComponent (SFC) is created to learn the
 * basics of Vue, and includes more comments than usual just to be as didactic
 * as possible. This is a working component, but it is not expected the usage
 * anywhere. Is only meant to serve as a template/memo/reference when creating
 * new ones. CieNTi'2021
 *
 * A Vue component is made by 3 elements: script, template and style.
 *
 * Component name: VuePress will take the component name from its filename. As
 * a naming convention, it is possible to use what is called 'kebab-case' or
 * 'PascalCase'. PascalCase seems like the de-facto and it also allows to be
 * referenced using a kebab-case naming form (if using kebab-case, PascalCase
 * cannot be used).
 *
 * ## `script`: default object
 *
 * The first a script have to return is the default object, which can be a mix
 * of data, lifecycle hooks
 * TODO:
 */
export default {
  /*
   * ### `data`: Object or Function?
   *
   * When expecting multiple isolated components, data must be a function so a
   * independent object instance is returned per component. If using a plain
   * object, properties are shared and updated in all affected components.
   *
   * Example object:
   *
   * ```js
   * data: {
   *   some_var: "some_val"
   * }
   * ```
   *
   * Example function:
   *
   * ```js
   * data: function() {
   *   return {
   *     some_var: "some_val"
   *   }
   * }
   * ```
   *
   * ### `data`: reactivity
   *
   * When a Vue instance is created, it adds all the properties found in data
   * object to Vue's reactivity system. This means that a change on any of this
   * properties will trigger a reaction on the view side. This will not happen
   * if a property is created after Vue creation.
   */
  data: function() {
    return {
      somePropA: "click me!"
    }
  },
  /*
   * ### `props`
   *
   * Custom attributes attached to components that becomes instance properties.
   * This is the way to pass data from a parent to a child element.
   *
   * Naming and casing: HTML attributes are case-insensitive, so there is no
   * way to distinguish a camelCased name. For this reason, in HTML it will be
   * used kebab-cased names, while in Javascript it will be camelCased:
   *
   * ```
   * HTML ......: <blog-post post-title="Hello!"></blog-post>
   * props .....: [ 'postTitle' ]
   * template ..: '<h3>{{ postTitle }}</h3>
   * ```
   *
   * There is no limit on the amount of props, they can hold any kind of value
   * and they can also be filtered/validated. The simples form is as follows:
   *
   * ```js
   * props: [ 'myWidth', 'myHeight' ]
   * ```
   *
   * When some enforcement, type, validation ... is required, a more elaborated
   * definition is needed. The following example shows one of each:
   *
   * ```js
   * props: {
   *   // Basic type check (`null` and `undefined` will pass type validations)
   *   propA: Number,
   *   // Multiple possible types
   *   propB: [ String, Number ],
   *   // Required string
   *   propC: {
   *     type: String,
   *     required: true
   *   },
   *   // Number with a default value
   *   propD: {
   *     type: Number,
   *     default: 100
   *   },
   *   // Object with a default value
   *   propE: {
   *     type: Object,
   *     // Object or array defaults must be returned from
   *     // a factory function
   *     default: function () {
   *       return { message: 'hello' }
   *     }
   *   },
   *   // Custom validator function
   *   propF: {
   *     validator: function (value) {
   *       // The value must match one of these strings
   *       return ['success', 'warning', 'danger'].indexOf(value) !== -1
   *     }
   *   }
   * }
   * ```
   */
  props: {
    somePropB: {
      type: String,
      required: true
    }
  },
  /*
   * ### Computed properties (the fastest way to declare functions in Vue)
   *
   * When starting with Vue, one of the first thing missing is how to create a
   * simple function to do some task, as this is not just Node/Javascript, but
   * a framework with its own ways to make things work, tied and robust.
   *
   * When we want to use a function from an element, what we want in Vue is to
   * get or set a computed property. One of the basic usages is to remove logic
   * from templates, so they remain in a simple and declarative form, while all
   * the logic is located in a single place.
   *
   * Example:
   *
   * ```js
   * computed: {
   *   // Some nice description
   *   someFunction: function() {
   *     return 'Hello!';
   *   }
   * }
   * ```
   *
   * This can be accessed from the template by interpolation:
   *
   * ```html
   * <div id="example">
   *   <p>Some computed message: "{{ someFunction }}"</p>
   * </div>
   * ```
   *
   * The common and default usage of a computed property is to retrieve some
   * value (getter), but it can also be used to modify values (setter).
   *
   * Get & set example:
   *
   * ```js
   * computed: {
   *   myPropertyName: {
   *     // getter
   *     get: function () {
   *       return 'Hi! ' + this.otherProperty;
   *     },
   *     // setter
   *     set: function (newValue) {
   *       this.otherProperty = newValue;
   *     }
   *   }
   * }
   * ```
   */
  computed: {
    somePropC: function() {
      return `A: ${this.somePropA} + B: ${this.somePropB}`;
    }
  }
  /*
   * ### Lifecycle hooks
   *
   * Each Vue instance/component goes through a series of initialization steps
   * when it’s created. The hooks in order are as follows:
   *
   * - beforeCreate
   * - created
   * - beforeMount
   * - mounted
   * - beforeUpdate
   * - updated
   * - beforeDestroy
   * - destroyed
   *
   * Example:
   *
   * ```js
   * created: function () {
   *   // `this` points to the component instance
   *   console.log(this);
   * }
   * ```
   */
  // Write your hooks here
  /*
   * ### Events and Methods
   *
   * It is possible to react to DOM events and run some JavaScript. In Vue, it
   * is accomplished by using `v-on` (or its shorthand `@`).
   *
   * Example:
   *
   * ```html
   * <button v-on:click="counter += 1">Add 1</button>
   * ```
   *
   * Once the task is complex enough it makes no sense to write all the code
   * inside a `v-on`, and that is why it also accepts names of methods:
   *
   * Example:
   *
   * ```html
   * <button v-on:click="sayhi">Say Hi</button>
   * ```
   *
   * ```js
   * methods: {
   *   addone: function (event) {
   *     // `this` points to the Vue instance
   *     console.log(this);
   *     alert('Hi!');
   *     // `event` is the native DOM event
   *     if (event) {
   *       alert(event.target.tagName);
   *     }
   *   }
   * }
   * ```
   *
   * It is also possible to use methods in an inline JavaScript statement. In
   * that case, arguments are passed instead of the native DOM event.
   *
   * Example:
   *
   * ```html
   * <button v-on:click="saysomething('Hi!')">Say Hi</button>
   * <button v-on:click="saysomething('Bye!')">Say Bye</button>
   * ```
   *
   * In case it is also needed to access the native DOM event, it can be passed
   * by using the special `$event` variable.
   *
   * Example:
   *
   * ```html
   * <button v-on:click="saywithevent('Hi!', $event)">Say Hi</button>
   * <button v-on:click="saywithevent('Bye!', $event)">Say Bye</button>
   * ```
   *
   * ```js
   * methods: {
   *   saywithevent: function (message, event) {
   *     console.log(this);
   *     console.log(message);
   *     console.log(event);
   *     if (event) {
   *       // Stop default action for `click`
   *       event.preventDefault();
   *     }
   *     // Then only display an alert
   *     alert(event.target.tagName);
   *   }
   * }
   * ```
   *
   * There is much more information, like event or key modifiers. Please head
   * to: https://vuejs.org/v2/guide/events.html for full information
   */
  // Write your methods here
  /*
   * ### Watchers
   *
   * Vue states that the computed properties are more appropriate in most cases,
   * but there are some of them that may require a more generic way to react to
   * data changes, and that is where the watchers come into play.
   *
   * Most useful when it is expected to perform asynchronous/expensive actions
   * in response to changing data (like an active search while typing)
   *
   * A simplistic example requires too much lines for this file, so head to
   * https://vuejs.org/v2/guide/computed.html#Watchers for full information
   */
  // Write your watchers here
}
</script>

<template>
  <!-- Template Comment //-->
  <div class="card">
    <!-- 'v-bind' shorthand ':'. 'v-on' shorthand '@' //-->
    <p class="somePropA" @click="somePropA = 'changed value'">somePropA: {{ somePropA }}</p>
    <p class="somePropB">somePropB: {{ somePropB }}</p>
    <p class="somePropC">somePropC: {{ somePropC }}</p>
  </div>
</template>

<style lang="stylus" scoped>
  div.card {
    color: $$accentColor;
    border: 1px solid #808080;
    padding: 20px;
  }

  .somePropA {
    border: 2px dashed #808000;
    text-align: center;
    padding: 5px;
  }

  .somePropB {
    border: 2px dashed #008080;
    text-align: center;
    padding: 5px;
  }

  .somePropC {
    border: 2px dashed #800080;
    text-align: center;
    padding: 5px;
  }
</style>
